<template>
  <div id="experiences">
    <h1>EXPERIENCES</h1>
    <div id="timeline" ref="timeline">
      <div class="here">
        <v-icon>
          mdi-arrow-left
        </v-icon>
        Vous êtes ici
      </div>
      <div class="timeline">
        <div class="timeline-row" v-for="(experience, index) in experiences" :key="index">
          <div class="timeline-time">
            {{ experience.dateStart | formatDate | capitalize }}
          </div>
<!--          <div class="timeline-year"> {{ experience.dateStart.getFullYear() }}</div>-->
          <div class="timeline-content">
            <div class="content-body">
              <Experience :experience="experience"/>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Experience from "@/components/Experience";
export default {
  components: {Experience},
  data() {
    return {
      experiences: [
        {
          title: "Développeur Backend - Apprentissage",
          subtitle: "RetailMeNot, Vannes",
          dateStart: new Date(2020, 8, 1),
          dateEnd: new Date(2021, 7, 31),
          tasks: [
            "Développement d'un système unifier de gestion de tags sur les entités",
            "Maintenance & Optimisations de la plateforme"
          ],
          technologies: [
            "PHP", "TPL", "Docker", "Docker Compose", "Docker Swarm", "Hadoop", "Snowflake", "Elastic", "Solr", "RabbitMQ", "VueJS", "SQL", "NoSQL"
          ]
        },
        {
          title: "Développeur Backend - Stage",
          subtitle: "RetailMeNot, Vannes",
          dateStart: new Date(2020, 3, 30),
          dateEnd: new Date(2020, 7, 31),
          tasks: [
            "Migration d'un système de tracking de Hadoop vers Snowflake",
            "Développement d'un système unifier de gestion de tags sur les entités",
            "Développement d'un MonoRepo pour simplifier la gestion des micro-services",
          ],
          technologies: [
            "PHP", "TPL", "Docker", "Docker Compose", "Docker Swarm", "Hadoop", "Snowflake", "Elastic", "Solr", "RabbitMQ", "VueJS", "SQL", "NoSQL"
          ]
        },
        {
          title: "Développeur Backend - Stage",
          subtitle: "RetailMeNot, Vannes",
          dateStart: new Date(2019, 3, 1),
          dateEnd: new Date(2019, 7, 31),
          tasks: [
            "Développement d'un Alerting System",
            "Participation au développement d'un CMS",
            "Mise en service d'un segmenteur de requête",
            "Développement d'un SDK pour une API"
          ],
          technologies: [
            "PHP", "TPL", "Docker", "Docker Compose", "Elastic", "Solr", "RabbitMQ", "VueJS", "SQL", "NoSQL"
          ]
        },
        {
          title: "Développeur Backend - Stage",
          subtitle: "Z Models Distribution, Josselin",
          dateStart: new Date(2018, 3),
          dateEnd: new Date(2018, 5),
          tasks: [
            "Développement d'un Warehouse Management System",
          ],
          technologies: [
            "PHP", "TPL", "SQL", "SAGE", "MySQL"
          ]
        },
      ],
    }
  },
  methods: {
    isInViewport(elem) {
      const distance = elem.getBoundingClientRect();
      return (
          distance.top >= 0 &&
          distance.left >= 0 &&
          distance.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
          distance.right <= (window.innerWidth || document.documentElement.clientWidth)
      );
    }
  },
  filters: {
    formatDate(value) {
      const options = { year: 'numeric', month: 'short' };
      return value.toLocaleDateString(undefined, options);
    },
    capitalize(value) {
      if (!value) return ''
      value = value.toString()
      return value.charAt(0).toUpperCase() + value.slice(1)
    }
  }
}
</script>
<style scoped lang="scss">
@import url('https://fonts.googleapis.com/css2?family=Poppins:wght@500&display=swap');
$primary-color: #5B71EB;

* {
  font-family: 'Poppins', sans-serif;
}

#experiences {
  padding: 50px calc(100vw / 12);
  background-color: #48D48E;
}


#timeline{
  list-style: none;
  position: relative;
  padding: 20px;
  margin: 0 auto;
  overflow: hidden;
  .here {
    position: relative;
    top: -20px;
    left: 50%;
    font-weight: bold;
    animation: slide 2s ease infinite;
  }
  .timeline-row{
    padding-left: 50%;
    z-index: 10;
    position: relative;
    .timeline-time{
      position: absolute;
      left: 50%;
      text-align: left;
      margin-left: 10px;
      font-size: 17px;
      line-height: 35px;
      top: 30px;
    }
    .timeline-year{
      position: absolute;
      top: 30px;
      left: 49%;
      margin-left: -15px;
      width: 60px;
      height: 60px;
      text-align: center;
      overflow: hidden;
      padding: 3px;
      font-size: 14px;
      z-index: 100;
    }
    .timeline-content{
      position: relative;
      color: #333333;
      margin-right: 0;
      margin-left: 110px;
      margin-bottom: 20px;
      min-height: 80px;
      .content-body{
        position: relative;
        z-index: 10;

      }
    }
    .timeline-content:after{
      content: "";
      position: absolute;
      top: 60px;
      left: -110px;
      height: 4px;
      width: 110px;
      background-color: rgba(0, 0, 0, 0.2);
      z-index: -1;
    }
  }
  .timeline-row:nth-child(odd){
    padding-left: 0;
    padding-right: 50%;
    .timeline-time{
      left: auto;
      right: 50%;
      text-align: right;
      margin-right: 10px;
      margin-left: 0;
    }
    .timeline-content{
      margin-right: 110px;
      margin-left: 0;
    }
    .timeline-content:after{
      left: auto;
      right: -110px;
    }
  }
  @media screen and (max-width:1200px){

    .here {
      left: 40px;
    }

    .intitule {
      color: black;
      font-size: 20px;
      line-height: 1.28571;
      letter-spacing: -.4px;
      font-weight: bold;
    }

    .timeline{
      .timeline-row {
        position: relative;
        right: auto;
        top: 0;
        padding: 0;
        margin: 0 0 16px 56px;
      }
      .timeline-row:nth-child(odd){
        padding-right: 0;
        .timeline-content{
          margin-right: 0;
          margin-left: auto;
        }
        .timeline-time {
          position: relative;
          right: auto;
          left: auto;
          top: 0;
          text-align: left;
          margin: 0 0 0 40px;
        }
      }
      .timeline-year{
        top: 40px;
        left: -55px;
        margin-left: 0;
        padding: 0;
      }
      .timeline-time {
        position: relative;
        right: auto;
        left: auto;
        top: 0;
        text-align: left;
        font-size: 15px;
        margin: 0 0 0 40px;
      }
      .timeline-content{
        margin-left: auto;
        box-shadow: 0 1px 2px rgba(0, 0, 0, 0.1);
        position: relative;
      }
      .timeline-content:after{
        right: auto !important;
        left: -25px !important;
        width: 25px;
        top: 30px;
      }
    }
    .timeline:after{
      left: 50px;
    }

  }
}
.timeline:after{
  content: "";
  position: absolute;
  top: 0;
  left: 50%;
  background-color: rgba(0, 0, 0, .5);
  height: 100%;
  width: 4px;
  border-radius: 4px;
  margin-left: -2px;
  display: block;
}

@keyframes slide
{
  0% {margin-left: 0;}
  50% {margin-left: 10px;}
  100% {margin-left: 0;}
}

</style>
